varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D lut;
uniform float transitionRatio; // between 0.0 to 1.1

void main()			
{
    // vec3 originColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
    vec3 originColor = texture2D(CC_Texture0, v_texCoord).xyz;

    float b = originColor.b * 15.0;
    float floorB = floor(b);

    vec2 lutCoord1;
    lutCoord1.x = floorB * 0.0625 + 0.05859*originColor.r + 0.00195;
    lutCoord1.y = originColor.g; // * 0.9375 + 0.03125;

    vec3 color1 = texture2D(lut, lutCoord1).xyz;
    lutCoord1.x = lutCoord1.x + 0.0625;
    vec3 color2 = texture2D(lut, lutCoord1).xyz;

    float rate = b - floorB;
    // gl_FragColor = originColor * (1.0 - transitionRatio) + (color1 * (1.0 - rate) + color2 * rate) * transitionRatio;
    gl_FragColor = vec4(originColor * (1.0 - transitionRatio) + (color1 * (1.0 - rate) + color2 * rate) * transitionRatio, 1.0);
}

// void main()
// {
//     vec3 originColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);

//     float b = originColor.b * 15.0;
//     float floorB = floor(b);

//     vec2 lutCoord1;
//     lutCoord1.x = floorB * 0.0625 + 0.05859*originColor.r + 0.00195;
//     lutCoord1.y = originColor.g; // * 0.9375 + 0.03125;

//     vec3 color1 = texture2D(lut, lutCoord1);
//     lutCoord1.y = lutcoord1.y + 0.0625;
//     vec3 color2 = texture2D(lut, lutCoord1);

//     float rate = b - floorB;
//     gl_FragColor = vec4(originColor * (1.0 - transitionRatio) + (color1 * (1.0 - rate) + color2 * rate) * transitionRatio,1.0);
// }


// 
// vec4 getLutColor (vec4 originColor, sampler2D lut)
// {
//     // Get grid position by blue value
//     float b = originColor.b * 15.0;
//     float floorB = floor(b);
//     float startX = floorB / 16.0;

//     // Get position in grid by red value
//     float r = 15.0/256.0*originColor.r + 0.5/256.0;
//     vec2 lutCoord1;
//     lutCoord1.x = startX + r;
//     lutCoord1.y = originColor.g; // * 0.9375 + 0.03125;

//     // Get another color make color transition smooth
//     vec2 lutCoord2;
//     lutCoord2.x = (floorB + 1.0)/16.0 + r;
//     lutCoord2.y = lutCoord1.y;

//     vec4 color1 = texture2D(lut, lutCoord1);
//     vec4 color2 = texture2D(lut, lutCoord2);

//     float rate2 = b - floorB;
//     float rate1 = 1.0 - rate2;
//     color1 = color1 * rate1;
//     color2 = color2 * rate2;

//     return color1 + color2;
// }

// void main()         
// {
//     vec4 originColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
//     gl_FragColor = originColor * (1.0 - transitionRatio) + getLutColor(originColor, lut) * transitionRatio;
// }